package com.ultraboodog;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.image.BufferStrategy;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferInt;

import javax.swing.ImageIcon;
import javax.swing.JFrame;

import com.ultraboodog.entity.mob.Player;
import com.ultraboodog.graphics.Screen;
import com.ultraboodog.input.Keyboard;
import com.ultraboodog.input.Mouse;
import com.ultraboodog.level.End;
import com.ultraboodog.level.Level;
import com.ultraboodog.level.WaterLevel1;
import com.ultraboodog.level.WaterLevel2;
import com.ultraboodog.level.WaterLevel3;
import com.ultraboodog.level.WaterLevel4;
import com.ultraboodog.level.WaterLevel5;
import com.ultraboodog.level.WaterLevel6;

@SuppressWarnings("serial")
public class Game extends Canvas implements Runnable
{
	public static int width = 250;
	public static int height = 200;
	public static int scale = 3;
	public static String title = "Ludum Dare 29 \"Beneath the Surface\" - Scuba Sam";
	private static long startTimer = 0L;

	private Thread thread;
	private boolean running = false;

	public Screen screen;
	public static Keyboard keyboard;
	public static Mouse mouse;
	private Level level;
	private static Player player;

	public static int theLevel = 0;

	public static boolean gameOver = false;

	public static boolean levelOne = true, levelTwo = false, levelThree = false, levelFour = false, levelFive = false, levelSix = false, end = false;
	public static boolean levelOneTimer = false, levelTwoTimer = false, levelThreeTimer = false, levelFourTimer = false, levelFiveTimer = false, levelSixTimer = false, levelEndTimer = false;
	public static boolean win = false;
	private static WaterLevel1 waterLevel1 = new WaterLevel1("/textures/maps/waterLevel1.png");
	private static WaterLevel2 waterLevel2 = new WaterLevel2("/textures/maps/waterLevel2.png");
	private static WaterLevel3 waterLevel3 = new WaterLevel3("/textures/maps/waterLevel3.png");
	private static WaterLevel4 waterLevel4 = new WaterLevel4("/textures/maps/waterLevel4.png");
	private static WaterLevel5 waterLevel5 = new WaterLevel5("/textures/maps/waterLevel5.png");
	private static WaterLevel6 waterLevel6 = new WaterLevel6("/textures/maps/waterLevel6.png");
	private static End endLevel = new End("/textures/maps/end.png");

	public static boolean playMusic = true;
	public static boolean pause = false;
	public static boolean theTitle = true;
	public static boolean theHelp = false;

	private BufferedImage image = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
	private int[] pixels = ((DataBufferInt) image.getRaster().getDataBuffer()).getData();

	public Game()
	{
		init();
	}

	Sound background = new Sound("res/sounds/background2.wav");
	Sound bubble = new Sound("res/sounds/bubbles.wav");
	public void init()
	{
		screen = new Screen(width, height);
		keyboard = new Keyboard();
		mouse = new Mouse();

		level = waterLevel1;

		updateLevel();
		player = new Player(2 * 16, 2 * 16, keyboard);
		level.add(player);

		bubble.play();

		addKeyListener(keyboard);
		addFocusListener(keyboard);
		addMouseListener(mouse);
		addMouseMotionListener(mouse);
	}

	public static int getWindowWidth()
	{
		return width * scale;
	}

	public static int getWindowHeight()
	{
		return height * scale;
	}

	public void updateLevel()
	{
		if (level.level == 1 && levelOne)
		{
			levelOne = false;
			levelTwo = true;
			levelOneTimer = true;
			theLevel = 1;
			level = waterLevel1;
		} else if (level.level == 2 && levelTwo)
		{
			levelTwo = false;
			levelThree = true;
			levelOneTimer = false;
			levelTwoTimer = true;
			
			if (WaterLevel1.time <= 5) Player.score += 10;
			else if (WaterLevel1.time <= 12 && WaterLevel1.time >= 6) Player.score += 15;
			else if (WaterLevel1.time >= 13) Player.score += 30;
			
			level = waterLevel2;
			theLevel = 2;
			player = new Player(2 * 16, 2 * 16, keyboard);
			level.add(player);
		} else if (level.level == 2 && levelThree)
		{
			levelThree = false;
			levelFour = true;
			levelTwoTimer = false;
			levelThreeTimer = true;
			level = waterLevel3;
			
			if (WaterLevel2.time <= 20) Player.score += 20;
			else if (WaterLevel2.time <= 59 && WaterLevel2.time >= 21) Player.score += 40;
			else if (WaterLevel2.time >= 60) Player.score += 55;
			
			theLevel = 3;
			player = new Player(1 * 16, 4 * 16, keyboard);
			level.add(player);
		} else if (level.level == 2 && levelFour)
		{
			levelFour = false;
			levelFive = true;
			levelThreeTimer = false;
			levelFourTimer = true;
			level = waterLevel4;
			
			if (WaterLevel3.time <= 50) Player.score += 30;
			if (WaterLevel3.time <= 100 && WaterLevel3.time >= 51) Player.score += 50;
			if (WaterLevel3.time <= 149 && WaterLevel3.time >= 101) Player.score += 70;
			if (WaterLevel3.time >= 150) Player.score += 90;
			
			theLevel = 4;
			player = new Player(2 * 16, 2 * 16, keyboard);
			level.add(player);
		} else if (level.level == 2 && levelFive)
		{
			levelFive = false;
			levelSix = true;
			levelFourTimer = false;
			levelFiveTimer = true;
			level = waterLevel5;
			
			if (WaterLevel4.time <= 40) Player.score += 30;
			else if (WaterLevel4.time <= 100 && WaterLevel4.time >= 41) Player.score += 50;
			else if (WaterLevel4.time <= 160 && WaterLevel4.time >= 101) Player.score += 70;
			else if (WaterLevel4.time >= 161) Player.score += 95;
			
			theLevel = 5;
			player = new Player(2 * 16, 2 * 16, keyboard);
			level.add(player);
		} else if (level.level == 2 && levelSix)
		{
			levelSix = false;
			end = true;
			levelFiveTimer = false;
			levelSixTimer = true;
			level = waterLevel6;
			
			if (WaterLevel5.time <= 50) Player.score += 35;
			else if (WaterLevel5.time <= 100 && WaterLevel5.time >= 51) Player.score += 50;
			else if (WaterLevel5.time <= 160 && WaterLevel5.time >= 101) Player.score += 75;
			else if (WaterLevel5.time <= 199 && WaterLevel5.time >= 161) Player.score += 90;
			else if (WaterLevel5.time >= 200) Player.score += 110;
			
			theLevel = 6;
			player = new Player(7 * 16, 1 * 16, keyboard);
			level.add(player);
		} else if (level.level == 2 && end)
		{
			end = false;
			levelSixTimer = false;
			levelEndTimer = true;
			win = true;
			level = endLevel;
			
			if (WaterLevel6.time <= 5) Player.score += 40;
			else if (WaterLevel6.time <= 9 && WaterLevel6.time >= 6) Player.score += 60;
			else if (WaterLevel6.time >= 10) Player.score += 100;
			
			theLevel = 7;
			player = new Player(4 * 16, 4 * 16, keyboard);
			level.add(player);
		}
	}

	public static void createWindow()
	{
		startTimer = System.currentTimeMillis();
		JFrame frame = new JFrame();
		Game game = new Game();
		frame.setIconImage(new ImageIcon("res/textures/icon.png").getImage());
		frame.setTitle(title);
		frame.pack();
		frame.add(game);
		frame.setSize(width * scale, height * scale);
		frame.setLocationRelativeTo(null);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setResizable(false);
		frame.setVisible(true);

		game.start();
	}

	public synchronized void start()
	{
		running = true;
		thread = new Thread(this, "Main");
		thread.start();
	}

	public synchronized void stop()
	{
		running = false;
		try
		{
			thread.join();
		} catch (InterruptedException e)
		{
			e.printStackTrace();
		}
	}

	public void run()
	{
		requestFocus();

		long lastTime = System.nanoTime();
		double delta = 0;
		double ns = 1000000000.0 / 60.0;
		long timer = System.currentTimeMillis();
		int frames = 0;
		int updates = 0;
		System.out.println("Took " + ((System.currentTimeMillis() - startTimer) / 1000.0) + " seconds to load!");
		while (running)
		{
			long now = System.nanoTime();
			delta += (now - lastTime) / ns;
			lastTime = now;
			if (delta >= 1)
			{
				update();
				updates++;
				delta--;
			}
			render();
			frames++;
			if (System.currentTimeMillis() - timer > 1000)
			{
				timer += 1000;
				System.out.println(updates + " ups, " + frames + " fps");
				if (WaterLevel1.time == 10 || WaterLevel2.time == 10 || WaterLevel3.time == 10 || WaterLevel4.time == 10 || WaterLevel5.time == 10 || WaterLevel6.time == 5) bubble.play();
				if (!theTitle)
				{
					if (!theHelp)
					{
						if (!pause)
						{
							if (level.level == 1 && levelOneTimer) WaterLevel1.time--;
							else if (level.level == 1 && levelTwoTimer) WaterLevel2.time--;
							else if (level.level == 1 && levelThreeTimer) WaterLevel3.time--;
							else if (level.level == 1 && levelFourTimer) WaterLevel4.time--;
							else if (level.level == 1 && levelFiveTimer) WaterLevel5.time--;
							else if (level.level == 1 && levelSixTimer) WaterLevel6.time--;
							else if (level.level == 1 && levelEndTimer) End.time--;
						}
					}
				}
				updates = 0;
				frames = 0;
			}
		}
	}

	public void update()
	{
		keyboard.update();

		if (keyboard.play) theTitle = false;

		if (gameOver) if (keyboard.exit) System.exit(0);

		if (theHelp) if (keyboard.back)
		{
			theHelp = false;
			theTitle = true;
		}

		if (theTitle || pause) if (keyboard.exit) System.exit(0);
		if (theTitle) if (keyboard.help) theHelp = true;

		if (!theTitle)
		{
			if (keyboard.pause) pause = true;
			if (keyboard.unpause) pause = false;
		}

		if (gameOver)
		{
			background.stop();
			background.drain();
		}

		if (!theTitle)
		{
			if (!theHelp)
			{
				if (!pause)
				{
					if (!gameOver)
					{
						if (WaterLevel1.time <= 0 || WaterLevel2.time <= 0 || WaterLevel3.time <= 0 || WaterLevel4.time <= 0 || WaterLevel5.time <= 0 || WaterLevel6.time <= 0 || End.time <= 0) gameOver = true;

						level.update();

						if (level.level >= 2) level.level = 0;
						if (player.advanceCollision(player.xa, player.ya)) level.level++;

						if (playMusic)
						{
							if (keyboard.mute) background.stop();
							else background.loop();
						}

						updateLevel();
					}
				}
			}
		}
	}

	public void render()
	{
		BufferStrategy bs = getBufferStrategy();
		if (bs == null)
		{
			createBufferStrategy(3);
			return;
		}

		screen.clear();
		double xScroll = player.x - screen.width / 2;
		double yScroll = player.y - screen.height / 2;
		level.render((int) xScroll, (int) yScroll, screen);

		for (int i = 0; i < pixels.length; i++)
			pixels[i] = screen.pixels[i];

		Graphics g = bs.getDrawGraphics();
		g.drawImage(image, 0, 0, getWidth(), getHeight(), null);

		g.setColor(Color.BLACK);
		g.setFont(new Font("Arial", 1, 6 * scale));

		if (level.level == 1 && levelOneTimer) g.drawString("Time Left: " + WaterLevel1.time, 2, 15);
		if (level.level == 1 && levelTwoTimer) g.drawString("Time Left: " + WaterLevel2.time, 2, 15);
		if (level.level == 1 && levelThreeTimer) g.drawString("Time Left: " + WaterLevel3.time, 2, 15);
		if (level.level == 1 && levelFourTimer) g.drawString("Time Left: " + WaterLevel4.time, 2, 15);
		if (level.level == 1 && levelFiveTimer) g.drawString("Time Left: " + WaterLevel5.time, 2, 15);
		if (level.level == 1 && levelSixTimer) g.drawString("Time Left: " + WaterLevel6.time, 2, 15);
		g.drawString("Score: " + Player.score, 2, 32);
		g.drawString("Level: " + theLevel, 2, 49);
		if (!pause) g.drawString("Press Esc to pause", 2, getWindowHeight() - 40);

		if (gameOver)
		{
			g.fillRect(0, 0, getWidth(), getHeight());
			g.setColor(Color.WHITE);
			g.setFont(new Font("Arial", 1, 8 * scale));
			if (!win) g.drawString("You Lose!", (getWindowWidth() / 2) - 61, 50);
			if (win) g.drawString("You Win!", (getWindowWidth() / 2) - 53, 50);
			g.setFont(new Font("Arial", 1, 6 * scale));
			g.drawString("Your Score: " + Player.score, (getWindowWidth() / 2) - 65, 125);
			if (!win) g.drawString("Level You Got To: " + theLevel, (getWindowWidth() / 2) - 92, 150);
			g.drawString("Press Z to quit!", (getWindowWidth() / 2) - 72, (getWindowHeight() / 2) + 80);
			
			if (win && Player.score >= 405) g.drawString("Perfect Score!", (getWindowWidth() / 2) - 102, 150);
			if (win && Player.score <= 404 && Player.score >= 261) g.drawString("Awesome!", (getWindowWidth() / 2) - 49, 150);
			if (win && Player.score <= 260 && Player.score >= 201) g.drawString("My dog could finish faster than you!", (getWindowWidth() / 2) - 173, 150);
			if (win && Player.score <= 200 && Player.score >= 166) g.drawString("You finished slower than Molasses in January in Canada!", (getWindowWidth() / 2) - 300, 150);
			if (win && Player.score == 165) g.drawString("At least you finished...", (getWindowWidth() / 2) - 65, 150);
		}
		
		if (pause)
		{
			g.setColor(new Color(0, 0, 0, 220));
			g.fillRect(0, 0, getWindowWidth(), getWindowHeight());
			g.setColor(Color.WHITE);
			g.setFont(new Font("Arial", 1, 6 * scale));
			g.drawString("Paused", (getWindowWidth() / 2) - 36, 100);
			g.drawString("Press Q to unpause!", (getWindowWidth() / 2) - 90, getWindowHeight() / 2);
			g.drawString("Press Z to quit!", (getWindowWidth() / 2) - 72, (getWindowHeight() / 2) + 40);
		}

		if (theTitle)
		{
			g.setColor(new Color(0, 0, 0));
			g.fillRect(0, 0, getWindowWidth(), getWindowHeight());
			g.setColor(new Color(255, 255, 255));
			g.setFont(new Font("Arial", 1, 10 * scale));
			g.drawString("Scuba Sam", (getWindowWidth() / 2) - 75, 200);
			g.setFont(new Font("Arial", 1, 7 * scale));
			g.drawString("Press E to play!", (getWindowWidth() / 2) - 74, getWindowHeight() / 2);
			g.drawString("Press X for help!", (getWindowWidth() / 2) - 77, (getWindowHeight() / 2) + 40);
			g.drawString("Press Z to quit!", (getWindowWidth() / 2) - 72, (getWindowHeight() / 2) + 80);
		}

		if (theHelp)
		{
			theTitle = false;
			g.setColor(new Color(0, 0, 0));
			g.fillRect(0, 0, getWindowWidth(), getWindowHeight());
			g.setColor(new Color(255, 255, 255));
			g.setFont(new Font("Arial", 1, 10 * scale));
			g.drawString("Help", (getWindowWidth() / 2) - 28, 100);
			g.setFont(new Font("Arial", 1, 7 * scale));
			g.drawString("Move with WASD or the arrow keys. Find the sinkhole to get to the", 30, 175);
			g.drawString("next level. Avoid the dark slow sand, and try to walk in the bright", 30, 200);
			g.drawString("fast sand. If the sinkhole is inaccessible, then find the teleporter (the", 30, 225);
			g.drawString("green sand) Make sure you finish the maze before the time limit, or", 30, 250);
			g.drawString("you'll drown, because your air is running low! Finish the level", 30, 275);
			g.drawString("faster to get a better score!", 30, 300);
			g.drawString("Make sure you have fun!", 30, 375);

			g.drawString("Press C to go back", 30, getWindowHeight() - 70);
		}

		if (win)
		{
			g.setColor(Color.GREEN);
			g.setFont(new Font("Helvetica", 1, 32));
			if (!gameOver) g.drawString("You Win!", (getWindowWidth() / 2) - 40, 100);
		}

		g.setColor(new Color(0, 148, 255, 10));
		g.fillRect(0, 0, getWidth(), getHeight());
		g.dispose();
		bs.show();
	}

	public static void main(String[] args)
	{
		createWindow();
	}
}
