package com.ultraboodog.entity.mob;

import com.ultraboodog.graphics.AnimatedSprite;
import com.ultraboodog.graphics.Screen;
import com.ultraboodog.graphics.SpriteSheet;

public class Crab extends Mob
{
	public AnimatedSprite dumbCrabDown = new AnimatedSprite(SpriteSheet.dumbCrabDown, 16, 16, 3, 8);
	public AnimatedSprite dumbCrabUp = new AnimatedSprite(SpriteSheet.dumbCrabUp, 16, 16, 3, 8);
	public AnimatedSprite dumbCrabRight = new AnimatedSprite(SpriteSheet.dumbCrabRight, 16, 16, 3, 8);
	public AnimatedSprite dumbCrabLeft = new AnimatedSprite(SpriteSheet.dumbCrabLeft, 16, 16, 3, 8);

	private AnimatedSprite animSprite = dumbCrabDown;
	
	private double xa = 0, ya = 0;
	private int time = 0;
	
	private boolean walking = false;
	
	public Crab(int x, int y)
	{
		this.x = x;
		this.y = y;
		sprite = animSprite.getSprite();
		dir = Direction.DOWN;
	}
	
	public void update()
	{
		time++;
		
		if (walking) animSprite.update();
		else animSprite.setFrame(0);
		
		if (time % (random.nextInt(50) + 30) == 0)
		{
			xa = random.nextInt(3) - 1;
			ya = random.nextInt(3) - 1;
			if (random.nextInt(4) == 0)
			{
				xa = 0;
				ya = 0;
			}
		}
		
		if (ya < 0)
		{
			dir = Direction.UP;
			animSprite = dumbCrabUp;
		} else if (ya > 0)
		{
			dir = Direction.DOWN;
			animSprite = dumbCrabDown;
		}
		
		if (xa < 0)
		{
			dir = Direction.LEFT;
			animSprite = dumbCrabLeft;
		} else if (xa > 0)
		{
			dir = Direction.RIGHT;
			animSprite = dumbCrabRight;
		}
		
		if (xa != 0 || ya != 0)
		{
			move(xa, ya);
			walking = true;
		} else walking = false;
	}
	
	public void render(Screen screen)
	{
		sprite = animSprite.getSprite();
		screen.renderMob((int) x, (int) y, this);
	}
}
