package com.ultraboodog.entity.mob;

import com.ultraboodog.Game;
import com.ultraboodog.graphics.AnimatedSprite;
import com.ultraboodog.graphics.Screen;
import com.ultraboodog.graphics.SpriteSheet;
import com.ultraboodog.input.Keyboard;

public class Player extends Mob
{
	public AnimatedSprite playerScubaDown = new AnimatedSprite(SpriteSheet.playerScubaDown, 16, 16, 3, 8);
	public AnimatedSprite playerScubaUp = new AnimatedSprite(SpriteSheet.playerScubaUp, 16, 16, 3, 8);
	public AnimatedSprite playerScubaRight = new AnimatedSprite(SpriteSheet.playerScubaRight, 16, 16, 3, 8);
	public AnimatedSprite playerScubaLeft = new AnimatedSprite(SpriteSheet.playerScubaLeft, 16, 16, 3, 8);

	private AnimatedSprite animSprite = playerScubaDown;

	private Keyboard keyboard;
	private boolean walking = false;
	
	public static int score = 0;

	public Player()
	{
		sprite = animSprite.getSprite();
		dir = Direction.DOWN;
	}
	
	public Player(Keyboard keyboard)
	{
		this.keyboard = keyboard;
		sprite = animSprite.getSprite();
		dir = Direction.DOWN;
	}

	public Player(int x, int y, Keyboard keyboard)
	{
		this.x = x;
		this.y = y;
		this.keyboard = keyboard;
		sprite = animSprite.getSprite();
		dir = Direction.DOWN;
	}

	public double xa, ya;
	public void update()
	{
		if (walking) animSprite.update();
		else animSprite.setFrame(0);

		xa = 0; 
		ya = 0;
		double speed;
		
		if (Game.levelFiveTimer)
		{
			if (teleportCollision(xa, ya))
			{
				teleport(5, 4);
			}
		}
		
		if (Game.levelSixTimer)
		{
			if (teleportCollision(xa, ya))
			{
				teleport(14, 6);
			}
		}
		
		if (slowCollision(xa, ya)) speed = 0.4;
		else if (fastCollision(xa, ya)) speed = 1.1;
		else speed = 0.8;
		
		if (keyboard.up)
		{
			ya -= speed;
			animSprite = playerScubaUp;
		}
		if (keyboard.down)
		{
			ya += speed;
			animSprite = playerScubaDown;
		}
		if (keyboard.left)
		{
			xa -= speed;
			animSprite = playerScubaLeft;
		}
		if (keyboard.right)
		{
			xa += speed;
			animSprite = playerScubaRight;
		}

		if (xa != 0 || ya != 0)
		{
			move(xa, ya);
			walking = true;
		} else walking = false;
	}

	public void render(Screen screen)
	{
		sprite = animSprite.getSprite();
		screen.renderPlayer((int) x, (int) y, sprite);
	}
}
