package com.ultraboodog.input;

import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public class Keyboard implements KeyListener, FocusListener
{
	private boolean[] keys = new boolean[246];
	
	public boolean up, down, left, right, mute, pause, unpause, play, exit, help, back;
	
	public void update()
	{
		up = keys[KeyEvent.VK_W] || keys[KeyEvent.VK_UP];
		down = keys[KeyEvent.VK_S] || keys[KeyEvent.VK_DOWN];
		left = keys[KeyEvent.VK_A] || keys[KeyEvent.VK_LEFT];
		right = keys[KeyEvent.VK_D] || keys[KeyEvent.VK_RIGHT];
		mute = keys[KeyEvent.VK_M];
		pause = keys[KeyEvent.VK_ESCAPE];
		unpause = keys[KeyEvent.VK_Q];
		play = keys[KeyEvent.VK_E];
		exit = keys[KeyEvent.VK_Z];
		help = keys[KeyEvent.VK_X];
		back = keys[KeyEvent.VK_C];
	}
	
	public void keyPressed(KeyEvent e)
	{
		keys[e.getKeyCode()] = true;
	}
	
	public void keyReleased(KeyEvent e)
	{
		keys[e.getKeyCode()] = false;
	}
	
	public void keyTyped(KeyEvent e)
	{
	}
	
	public void focusGained(FocusEvent e)
	{
	}

	public void focusLost(FocusEvent e)
	{
		for (int i = 0; i < keys.length; i++)
			keys[i] = false;
	}
}
